import numpy as np
import math
import torch
import torch.nn as nn
import torch.optim as optim
from torch.autograd import Variable
from torch.utils.data import DataLoader
from torch.utils import data
from os import listdir
from os import makedirs
from os.path import join
import torch.nn.functional as F
import torchvision
import torchvision.transforms as transforms
from PIL import Image
import time

def load_img(filepath):
    transform = transforms.Compose([transforms.ToTensor(), transforms.Normalize((0.5, 0.5, 0.5), (0.5, 0.5, 0.5))])
    img = Image.open(filepath)#.convert('YCbCr')
    img = transform(img)

    if img.size(0)<3:
        print("bug")
        print(filepath)
    
    return img

#dataset loader
class DatasetFromFolder(data.Dataset):
    def __init__(self, datadir):
        super(DatasetFromFolder, self).__init__()
        posdir = join(datadir, 'pedestrians_pos')
        filenames1 = [join(posdir, x) for x in listdir(posdir)]
        negdir = join(datadir, 'pedestrians_neg')
        filenames0 = [join(negdir, x) for x in listdir(negdir)]
        self.filenames = filenames1+filenames0

    def __getitem__(self,index):
        name = self.filenames[index]
        input = load_img(name)

        target = torch.zeros([1], dtype=torch.float)
        if name.find("neg") >=0:
            target[0] = 0 #no pedestrians
        elif name.find("pos") >=0:
            target[0] = 1 #pedestrian

        return input,target


    def __len__(self):
        return len(self.filenames)


##Classifier

class Classifier(nn.Module):
    def __init__(self):
        super(Classifier ,self).__init__()
        self.conv1 = ...
        self.conv2 = ...
        self.lin1 = ... 
        self.lin2 = ...
        self.lin3 = ...

    def forward(self,x):
        ...
        return x


def train():
    starttime = time.time()
    d_learning_rate = 1e-3
    sgd_momentum = 0.9

    num_epochs = 100
    num_w = 16
    batch_s = 32

    print("Training with :")
    print("Num epochs:",num_epochs)
    print("Num workers:",num_w)
    print("Batchsize:",batch_s)
    print("Learning rate:", d_learning_rate)
    print("Momentum:", sgd_momentum)


    #loading classifier
    net = Classifier()

    #Loss and optimizer
    criterion = ...
    optimizer = ...

    #loading data
    trainset = DatasetFromFolder("train")
    trainloader = DataLoader(trainset, num_workers=num_w, batch_size=batch_s, shuffle=True)

    for epoch in range(num_epochs):  # loop over the dataset multiple times
        net.train()
        print("Epoch:",epoch+1,"/",num_epochs)
        running_loss = 0.0
        for i, data in enumerate(trainloader, 0):
            # get the inputs
            inputs, labels = data

            # zero the parameter gradients
            ...
    
            # forward + backward + optimize
            ...
    
            # print statistics
            running_loss += loss.item()
            print('[%d, %5d] loss: %.3f' %
                   (epoch + 1, i + 1, running_loss / 2000))
            running_loss = 0.0

        if epoch % 10 == 9:
            test(net,num_w,batch_s)
    
    time_elapsed = time.time() - starttime
    print('Training complete in {:.0f}m {:.0f}s'.format(
        time_elapsed // 60, time_elapsed % 60))
    
    torch.save(net.state_dict(), "classifier.pth")


def test(net, num_w, batch_s):

    starttime = time.time()

    print("Testing with :")
    print("Num workers:",num_w)
    print("Batchsize:",batch_s)

    #setting the classifier in test mode
    net.eval()

    #loading data
    testset = DatasetFromFolder("test")
    testloader = DataLoader(testset, num_workers=num_w, batch_size=batch_s, shuffle=True)
    ngoodclassif = 0
    ntest = 0
    for i, data in enumerate(testloader, 0):
        # get the inputs
        inputs, labels = data

        #forward in the net
        ...

        #compute the number of well classified data and the total number of tests
        ...
    
    ratio = ngoodclassif/ntest
    print('Good classification ratio: %.2f %%' %(ratio*100))


def main():
    train()

if __name__ == '__main__':
    main()
