import cv2
import numpy as np
import matplotlib.pyplot as plt
import os, os.path

postraindir = "./train/pedestrians_pos/"
negtraindir = "./train/pedestrians_neg/"
postestdir = "./test/pedestrians_pos/"
negtestdir = "./test/pedestrians_neg/"
sizehog = 3780

npos = len(os.listdir(postraindir))
nneg = len(os.listdir(negtraindir))
ndesc = npos + nneg

hog = cv2.HOGDescriptor()
hogdescs = np.zeros((ndesc, sizehog+1))
labels = np.zeros((ndesc,1))

##preparing data

idx = 0
for filename in os.listdir(postraindir) :
  img = cv2.imread(os.path.join(postraindir,filename), cv2.IMREAD_GRAYSCALE)

  h = np.transpose(hog.compute(img))
  v = np.ones((1,1))
  hogdescs[idx,:] = np.concatenate((h, v),1);
  labels[idx,0] = 1;
  idx = idx + 1

for filename in os.listdir(negtraindir) :
  img = cv2.imread(os.path.join(negtraindir,filename), cv2.IMREAD_GRAYSCALE)

  h = np.transpose(hog.compute(img))
  v = np.ones((1,1))
  hogdescs[idx,:] = np.concatenate((h, v),1);
  labels[idx, 0] = -1
  idx = idx + 1


## Write the SVM training code below

#uncomment below to plot a training error called errtrain
#plt.plot(errtrain)
#plt.title("Training error")
#plt.show()

## Write the test code below
